/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 232 by dpavlin, Sun Oct 24 11:55:02 2010 UTC revision 301 by dpavlin, Tue Apr 9 19:49:31 2013 UTC
# Line 47  lxc_hostname() { Line 47  lxc_hostname() {
47  }  }
48    
49  lxc_ip() {  lxc_ip() {
50          grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 ||          ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51          grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'          grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54  }  }
55    
56  lxc_status() {  lxc_status() {
57          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                    status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`     # 0.7.5
59                    test -z "$status" && status=`lxc-info -n $name | sed -e 's/^.* is //'` # 0.7.2
60                  boot="-"                  boot="-"
61                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
62                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
# Line 64  cleanup_init_scripts() { Line 68  cleanup_init_scripts() {
68          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
69    
70          ls \          ls \
71                    $rootfs/etc/rc?.d/*checkroot* \
72                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
73                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
74                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
75                  $rootfs/etc/rc?.d/*udev* \                  $rootfs/etc/rc?.d/*udev* \
76                    $rootfs/etc/rc?.d/*checkfs* \
77          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
78    
79          echo $1 > $rootfs/etc/hostname          echo $1 > $rootfs/etc/hostname
80            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
81  }  }
82    
83    
# Line 99  lxc_kill() { Line 106  lxc_kill() {
106          name=$1          name=$1
107          sig=$2          sig=$2
108    
109          init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`          ver=`lxc-version | cut -d: -f2 | sed 's/\.//g'`
110            opts=''
111            test $ver -ge 075 && opts='--'
112    
113            init_pid=`lxc-ps $opts -C init -o pid | grep "^$name" | cut -d" " -f2-`
114          if [ -z "$init_pid" ] ; then          if [ -z "$init_pid" ] ; then
115                  lxc-info -n $name                  lxc-info -n $name
116                  exit 1                  exit 1
# Line 128  lxc_start() { Line 139  lxc_start() {
139    
140          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
141                  lxc_log "$name start"                  lxc_log "$name start"
142                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
143                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
144                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
145                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
146                  lxc-info  -n $name                  lxc-info  -n $name
# Line 137  lxc_start() { Line 150  lxc_start() {
150    
151  lxc_watchdog() {  lxc_watchdog() {
152  name=$1  name=$1
153    cgroup=$(mount -t cgroup | awk '{ print $3 }')
154    test -d "$cgroup/lxc/$1" && cgroup="$cgroup/lxc"
155  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
156    run=$rootfs/var/run
157    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
158    cd $run || echo "can't cd watchdog into $run"
159    
160  while true; do  while true; do
161          vps_utmp=${rootfs}/var/run/utmp          tasks=`wc -l < $cgroup/${name}/tasks`
162          tasks=`wc -l < /cgroup/${name}/tasks`          stop_on=1 # init
163            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
164            if [ "$sulogins" -gt 0 ] ; then
165                    stop_on=`expr $stop_on + $sulogins`
166            fi
167    
168          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
169          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
170    
171                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
172                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
173    
174                  case $runlevel in                  case $runlevel in
175                  N*)                  N*)
176                          # nothing for new boot state                          # nothing for new boot state
177                  ;;                  ;;
178                  ??0)                  ??0|unknown)
179                          lxc_log "$name halt"                          lxc_log "$name halt"
180                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
181                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
# Line 171  while true; do Line 194  while true; do
194                  ;;                  ;;
195                  esac                  esac
196          else          else
197                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
198          fi          fi
199    
200          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
201          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
202  done  done
203    
204  lxc_log "$name watchdog exited"  lxc_log "$name watchdog exited"

Legend:
Removed from v.232  
changed lines
  Added in v.301

  ViewVC Help
Powered by ViewVC 1.1.26